package com.wsm.admin.device.mqtt;

import org.eclipse.paho.client.mqttv3.MqttClient;
import org.eclipse.paho.client.mqttv3.MqttConnectOptions;
import org.eclipse.paho.client.mqttv3.MqttTopic;
import org.eclipse.paho.client.mqttv3.persist.MemoryPersistence;

public class ClientMQTT {

//topic, demo只订阅了火警的topic，其他的添加topic到数组中即可
//      火警      - /chiefdata/push/fire_alarm/department/34/area/1/dev/3jyun-866971030771930
//      设备故障      - /chiefdata/push/fault_alarm/department/34/area/1/dev/3jyun-866971030771930
//      上下线     - /chiefdata/push/device_online_status/department/34/area/1/dev/3jyun-866971030771930
//      设备属性上报      - /chiefdata/push/dev_msg/department/34/area/1/dev/3jyun-866971030771930
//      服务器账号密码等私密信息请勿外泄    







    /**
     * 服务器地址
     */
    public static final String HOST = "tcp://swan.3jyun.com:8008";

    /**
     * 客户端id
     */
    private static final String clientId = "MQTT_FX_Client";

    private String userName = "httpAgent";
    private String passWord = "c3772e1bee68544284e47e8806a2a8ca";

    private MqttClient client;
    private MqttConnectOptions options;


    public void start() {
        try {
            // host为主机名，clientid即连接MQTT的客户端ID，一般以唯一标识符表示，MemoryPersistence设置clientid的保存形式，默认为以内存保存
            client = new MqttClient(HOST, clientId, new MemoryPersistence());
            // MQTT的连接设置
            options = new MqttConnectOptions();
            // 设置是否清空session,这里如果设置为false表示服务器会保留客户端的连接记录，设置为true表示每次连接到服务器都以新的身份连接
            options.setCleanSession(false);
            // 设置连接的用户名
            options.setUserName(userName);
            // 设置连接的密码
            options.setPassword(passWord.toCharArray());
            // 设置超时时间 单位为秒
            options.setConnectionTimeout(5);
            // 设置会话心跳时间 单位为秒 服务器会每隔1.5*20秒的时间向客户端发送个消息判断客户端是否在线，但这个方法并没有重连的机制
            options.setKeepAliveInterval(20);
            // 设置回调
            client.setCallback(new PushCallback());
            MqttTopic topic = client.getTopic(TopicCode.TOPIC_FIRE_ALARM);
            //setWill方法，如果项目中需要知道客户端是否掉线可以调用该方法。设置最终端口的通知消息
//遗嘱        options.setWill(topic, "close".getBytes(), 2, true);
            client.connect(options);
            /**
             * 订阅消息
             * 0代表“至多一次”
             * 1代表“至少一次”
             * 2代表“只有一次”
             */
            int[] qos  = {1,1,1,1};
            // 订阅topic ，最少一个，允许多个，加入数组中就可以了
            String[] subscribeTopic = {TopicCode.TOPIC_FIRE_ALARM, TopicCode.TOPIC_FAULT_ALARM, TopicCode.TOPIC_DEVICE_ONLINE_STATUS, TopicCode.TOPIC_DEV_MSG};
//            String[] topic1 = {TOPIC1};
            client.subscribe(subscribeTopic, qos);

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

//    public static void main(String[] args) throws MqttException {
//        ClientMQTT client = new ClientMQTT();
//        client.start();
//    }

}
